Index: squid/ChangeLog
===================================================================
RCS file: /cvsroot/squid-sf//squid/ChangeLog,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/ChangeLog	26 Jan 2000 03:23:09 -0000	1.1.1.2
+++ squid/ChangeLog	26 Jan 2000 03:25:00 -0000	1.1.1.3
@@ -1,10 +1,242 @@
+Changes to Squid-2.3.STABLE1 (Jan 9, 2000):
+
+	- Updated PAM authentication module from Henrik Nordstrom.
+	- Updated Bulgarian error messages from Svetlin Simeonov.
+	- Changed ACL routines so that User-Agent (browser) string
+	  is always taken from compiled HTTP request headers
+	  instead of passed as an argument to aclCreateChecklist.
+	- Added a 'strip' option to the 'uri_whitesace' configuration
+	  directive and made it the default behavior.  Whitespace
+	  found in URI's is now stripped out by default.
+	- Added chroot feature.  The 'chroot_dir' config option enables
+	  it and specifies the directory.
+	- Changed clientBuildReplyHeader so that the Age header is
+	  added only for cache hits, and only when we can calculate
+	  a valid, positive age value.
+	- Changed clientWriteComplete and clientGotNotEnough so
+	  that they keep persistent connections open for more types
+	  of replies that don't have bodies.
+	- Changed filemap.c routines to dynamically grow filemap
+	  space as needed.
+	- Added a hack to ftp.c to deal with ftp.netscape.com, which
+	  sometimes doesn't acknowledge PASV commands.
+	- Fixed FTP bug with ftpScheduleReadControlReply; there
+	  was not always a timeout handler on the control socket
+	  after the transfer completed.
+	- Fixed FTP filedescriptor leak from invalid PASV replies.
+	- Changed httpBuildRequestHeader so that it doesn't
+	  copy the Host header from the client request.  Instead
+	  we should generate our own Host header which is known
+	  to be correct.
+	- Changed storeTimestampsSet to adjust entry->timestamp
+	  if the response includes an Age header.
+	- Removed size limit from storeKeyHashBuckets.
+	- Changed fwdConnectStart from a "heavy" to a "light" event.
+	- Fixed an 'anonymize_headers' bug that affects unknown
+	  HTTP headers.  With the bug, if you list a header that
+	  Squid doesn't know about (such as "Charset"), it would
+	  add HDR_OTHER to the allow/deny mask.  This caused all
+	  unknown headers to be allowed or denied (depending on
+	  the scheme you use).  Now, with the bug fixed, an unknown
+	  header in the 'anonymize_headers' list is simply ignored.
+
+Changes to Squid-2.3.DEVEL3 ():
+
+	- Added MSNT auth module from Antonino Iannella.
+	- Added --enable-underscores configure option.  This allows
+	  Squid to accept hostnames with underscores in them.  Your
+	  DNS resolver may still complain about them, however.
+	- Added --heap-replacement configure option.  This enables
+	  the alternative cache replacement policies, such as
+	  GDSF, and LFUDA.
+	- WCCP establishes and registers with the router faster.	
+	- Added 'maxconn' acl type to limit the number of established
+	  connections from a single client IP address.  Submitted
+	  by Vadim Kolontsov.
+	- Close FTP data socket as soon as transfer completes
+	  (Alexander V. Lukyanov).
+	- Fixed ftpReadPass() to not clobber ctrl.message when
+	  the PASS command fails.
+	- Added a redirect.c patch so squidGuard is able to do
+	  per-user access control (Antony T Curtis).
+	- discard the pumpMethod() function, and instead use the
+	  fact that the request has a request entity (content-length
+	  present) (Henrik).
+	- Reload the MIME icons at reconfigure time (Radu Greab).
+	- Updated Richard Huveneers' SMB authentication module to
+	  his version 0.05 package.
+	- Fixed lib/heap.c::heap_delete() bug when deleting the
+	  last node.
+	- Fixed an integer conversion bug in
+	  lib/rfc1035.c::rfc1035AnswersUnpack().
+	- Fixed lib/rfc1738 routines to encode reserved characters,
+	  in addition to encoding the unsafe characters (Henrik).
+	- Changed the interface for splay compare and "walk"
+	  functions to take a void pointer, instead of a splayNode
+	  pointer (Henrik).
+	- Changed numerous HTTP parsing routines to use ssize_t
+	  instead of size_t.  This was done because size_t may be
+	  signed or unsigned.  When it is unsigned, gcc emits
+	  numerous "comparison is always true" warnings.  At least
+	  we know ssize_t is always signed.
+	- Fixed src/HttpHeaderTools::httpHeaderHasConnDir() and
+	  friends so that it properly handles multi-value lists.
+	- Added an "end" (ssize_t) parameter to
+	  src/HttpReply::httpReplyParse() so that we know exactly
+	  where to terminate the header buffer.
+	- Changed src/access_log.c::log_quote() so that it only
+	  encodes whitespace characters, and not all URL-special
+	  characters (Henrik).
+	- Added local port ACL type ("myport") (Henrik).
+	- Added maximum number of connections per client ("maxconn")
+	  as an ACL type.
+	- Fixed proxy authentication username/password parsing to
+	  be more robust (Henrik).
+	- Fixed ACL domain/host and domain/domain comparison
+	  functions yet again.  Eliminated duplicate code so that
+	  only src/url.c::matchDomainName() contains this mysterious
+	  code.
+	- Changed the 'http_port' option to accept an IP address
+	  or hostname as well (Henrik).
+	- Removed 'tcp_incoming_addr' option.
+	- Added an access control list for the redirector
+	  ('redirector_access').  Requests which match are sent to
+	  the redirector.  All requests. are redirected by default.
+	- Added the 'authenticate_ip_ttl' option.  It specifies
+	  how long a valid proxy authentication credential is
+	  bound to a specific address.
+	- Added 280, 488, 591, and 777 to "Safe_ports" ACL.
+	- Removed the unused and highly questionable 'forward_snmpd_port'
+	  option.
+	- Added an option to accept DNS messages from unknown nameservers.
+	  This may be necessary if replies come from a different address
+	  than queries are sent to.
+	- Added #includes for IP Filter files in netinet directory.
+	- Fixed a bug with retrying forwarded IMS requests (Henrik).
+	- Fixed a bug in src/client_side.c::clientInterpretRequestHeaders()
+	  where we were checking a cache-control bit before getting the
+	  mask from the HTTP headers (pallo@initio.no).
+	- Fixed a bug with "no_cache" access list.  If not defined,
+	  everything was uncachable by default.
+	- Fixed a bug with timed-out client-side HTTP connections.
+	  We didn't cancel the read handler, which could lead to 
+	  "rwstate != NULL" warnings.
+	- Changed comm_open() to only call fdAdjustReserved() for
+	  specific errors (ENFILE, EMFILE);
+	- Fixed NULL pointer bug in idnsParseResolvConf().
+	- Split CACHE_DIGEST_HIT into CD_PARENT_HIT and CD_SIBLING_HIT.
+	- Added DELETE request method.
+	- Added RFC 2518 HTTP status codes.
+	- Fixed handling of URL passwords when we need to rewrite a
+	  BASE HREF URL (Henrik).
+	- Fixed a bug with FTP requests where a request gets aborted,
+	  but we try to complete it anyway.  It would result in a
+	  "store_status != STORE_PENDING" assertion.  The solution
+	  is to check for ENTRY_ABORTED before reading from
+	  the control channel too.
+	- Changed FTP to retry a request if Squid fails to establish
+	  a PASV data connection (Henrik).
+	- Fixed numerous HTCP memory leaks and an uninitialized memory
+	  bug.
+	- Changed httpMaybeRemovePublic() with RFC 2518 and 2616 in
+	  mind (Henrik).
+	- Minor fixes for Rhapsody systems.
+	- Define _XOPEN_SOURCE_EXTENDED in squid.h so that AIX systems
+	  don't include varargs.h.
+	- Changed src/store_client.c::storeClientType() so that
+	  an entry can have more than one STORE_MEM_CLIENT.
+	- Changed src/store_client.c::storeClientReadHeader()
+	  to check swapfile metadata (Henrik).
+	- Changed src/url.c::urlCheckRequest() to return FALSE for
+	  any "https://" URL.  These should always be CONNECT
+	  instead.  If Squid gets an "https://" URL, it is a browser
+	  bug.
+	- Added numerous squid.conf options for controlling cache
+	  digests.   Previously these were hard-coded in
+	  src/store_digest.c.  (Martin Hamilton)
+	- Added 'cache_peer' option called 'digest-url' that
+	  lets you specify the URL for a peer's digest.
+	  (Martin Hamilton)
+	- Added DELAY_POOLS hacks to scan "slow" connections in
+	  a random order (David Luyer).
+	- ARP_ACL fixes from Damien Miller.  Linux 2.2.x uses a
+	  per-interface arp/neighbour cache, whereas 2.0.x uses a
+	  unified cache. Under 2.2.x you are required to specify
+	  a interface name when looking up ARP table entries with
+	  SIOCGARP.
+	- If the process umask is not set (i.e. 0), then Squid
+	  changes it to 007.
+
+Changes to Squid-2.3.DEVEL2 ():
+
+	- Added --enable-truncate configure option.
+	- Updated Czech error messages ()
+	- Updated French error messages ()
+	- Updated Spanish error messages ()
+	- Added xrename() function for better debugging.
+	- Disallow empty ("") password in aclDecodeProxyAuth()
+	  (BoB Miorelli).
+	- Fixed ACL SPLAY subdomain detection (again).
+	- Increased default 'request_body_max_size' from 100KB
+	  to 1MB in cf.data.pre.
+	- Added 'content_length' member to request_t structure
+	  so we don't have to use httpHdrGetInt() so often.
+	- Fixed repeatedly calling memDataInit() for every reconfigure.
+	- Cleaned up the case when fwdDispatch() cannot forward a
+	  request.  Error messages used to report "[no URL]".
+	- Added a check to return specific error messages for a
+	  "store_digest" request when the digest entry doesn't exist
+	  and we reach internalStart().
+	- Changed the interface of storeSwapInStart() to avoid a bug
+	  where we closed "sc->swapin_sio" but couldn't set the
+	  pointer to NULL.
+	- Changed storeDirClean() so that the rate it gets called
+	  depends on the number of objects deleted.
+	- Some WCCP fixes.
+	- Added 'hostname_aliases' option to detect internal requests
+	  (cache digests) when a cache has more than one hostname
+	  in use.
+	- Async I/O NUMTHREADS now configurable with --enable-async-io=N
+	  (Henrik Nordstrom).
+	- Added queue length to async I/O cachemgr stats (Henrik Nordstrom).
+	- Added OPTIONS request method.
+
+Changes to Squid-2.3.DEVEL1 ():
+
+	- Added WCCP support.  This adds the 'wccp_router' squid.conf
+	  option.
+	- Added internal DNS queries; Most installations can run
+	  without the external dnsserver processes.
+	- Rewrote much of the code that stores cache objects on
+	  disk.  Developed a programming interface that should
+	  allow new storage systems to be added easily.  This still
+	  is pretty ugly and needs a lot of work, however.
+	- Replaced async_io.c "tags" with callback data locks.
+	  This probably breaks async IO in a bad way.
+	- Tried to write an Async IO disk storage module.
+	- Added code to replace the StoreEntry linked list with a
+	  heap structure.  This allows for different replacement
+	  algorithms, instead of being stuck with LRU.  This adds
+	  the 'replacement_policy' squid.conf option. (John Dilley
+	  et al).
+	- Fixed HTCP queries by actually checking for freshness
+	  based on the HTCP header fields.
+	- Fixed passing of redirector command line arguments.
+	- Added 'request_header_max_size' squid.conf option.
+	- Added 'request_body_max_size' squid.conf option.
+	- Added 'reply_body_max_size' squid.conf option.
+	- Added 'peer_connect_timeout' squid.conf option.
+	- Added 'redirector_bypass' squid.conf option.
+	- Added RFC 2518 (WEBDAV) request methods.
+	
+
 Changes to Squid-2.2 (April 19, 1999):
 
 	- Removed all SNMP specific ACL code
 	  SNMP now uses generic squid ACL's
-	- Removed view-based access control
+	- Removed view-based access crontrol
 	- Cleaned up and simplified SNMP section of squid.conf
-	- Changed the SNMP code to use a tree structure.
+	- Changed the SNMP code to use a tree stucture.
 	- Added objects to MIB:	
 		Request Hit Ratio's
 		Byte Hit Ratio's
@@ -61,7 +293,7 @@
 		- The 'ident_lookup on|off' option has been replaced with
 		  an access list, so you can do lookups only for some
 		  client addresses.
-		- Added an 'ident_timeout' option to specify the amount
+		- Added an 'ident_timeout' option to specifiy the amount
 		  of time to wait for an ident lookup.
 	- Added a (local) hit rate to mempool metering.
 	- FTP Restarts (REST command) is now supported.
@@ -101,7 +333,7 @@
 		  as a percentage of the maximum for the pool in
 		  question (used to be all set to 1 second worth
 		  of traffic).  Pools are restored to this level
-		  on reconfiguration.
+		  on reconfiguratoin.
 	- Changed storeClientCopy to give a swap-in failure if 
 	  the number of open disk FD's is above the 'max_open_disk_fds'
 	  limit.  Otherwise, a very loaded cache will end up with
@@ -214,41 +446,14 @@
 	- Fixed logging of hierarchy codes for SSL requests (Henrik
 	  Nordstrom).
 	- Added some descriptions to mib.txt.
-	- Fixed a bug with non-hierarchical requests (e.g. POST)
+	- Fixed a bug with non-hierarchical requests (e.g. POST) 
 	  and cache digests.  We used to look up non-hierarchical
 	  requests in peer digests.  A false hit may cause Squid
 	  to forward a request to a sibling.  In combination with
 	  'Cache-control: only-if-cached, this generates 504 Gateway
 	  Timeout responses and the request may not be re-forwardable.
-	- Fixed a filedescriptor leak for some aborted requests.
-
-	2.2.STABLE5:
+	- Fixed a filedescriptor leak for some aborted requests.  
 
-	- Changed configure to look for IP-Filter header files
-	  in both /usr/include and /usr/include/netinet.
-	- Fixed an ACL subdomain comparison bug (aclDomainCompare).
-	- Fixed an ACL host <=> domain comparison bug
-	  (aclHostDomainCompare).
-	- Fixed a "xstrdup: tried to dup a NULL pointer!" bug
-	  caused by illegal hostname characters when certain
-	  ACL types are in use.
-	- Fixed res_init() bug in dnsserver.  We used to call
-	  res_init(), and then clear the RES_INIT bit in
-	  _res.options.  This caused res_init() to be
-	  called again as soon as we use gethostbyname(), and
-	  this second initialization wipes out our changing
-	  the nameservers.  The fix is just to NOT set
-	  _res.options to RES_DEFAULT after calling res_init().
-	- Changed FTP to close data sockets as soon as the transfer
-	  ends, rather than waiting for the reply message on the
-	  control socket (Alexander V. Lukyanov).
-	- Fixed some buffering problems between Squid and the
-	  unlinkd process.  By using file_write(), unlink requests
-	  were being buffered and experiencing long delays under
-	  heavy load.  Now use use good ol' write() instead.  Also
-	  added some feedback from unlinkd to squid so we can track
-	  the unlink request queue.  If the queue becomes too large,
-	  we block a little and wait for some acks from unlinkd.
 
 Changes to Squid-2.1 (November 16, 1998):
 
Index: squid/acconfig.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/Attic/acconfig.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/acconfig.h	26 Jan 2000 03:23:09 -0000	1.1.1.2
+++ squid/acconfig.h	26 Jan 2000 03:25:00 -0000	1.1.1.3
@@ -20,7 +20,7 @@
  *
  */
 @ TOP @
-/* $Id: acconfig.h,v 1.1.1.2 2000/01/26 03:23:09 hno Exp $ */
+/* $Id: acconfig.h,v 1.1.1.3 2000/01/26 03:25:00 hno Exp $ */
 
 /*********************************
  * START OF CONFIGURABLE OPTIONS *
@@ -48,6 +48,9 @@
 /* Define to use async disk I/O operations */
 #undef USE_ASYNC_IO
 
+/* Defines how many threads to use for async I/O */
+#undef NUMTHREADS
+
 /*
  * If you want to use Squid's ICMP features (highly recommended!) then
  * define this.  When USE_ICMP is defined, Squid will send ICMP pings
@@ -83,6 +86,11 @@
 #undef SQUID_SNMP
 
 /*
+ * Define to enable WCCP
+ */
+#define USE_WCCP 1
+
+/*
  * Squid frequently calls gettimeofday() for accurate timestamping.
  * If you are concerned that gettimeofday() is called too often, and
  * could be causing performance degradation, then you can define
@@ -229,6 +237,27 @@
 #undef HAVE_STATVFS
 
 /*
- * we check for struct mallinfo
+ * If --disable-internal-dns was given to configure, then we'll use
+ * the dnsserver processes instead.
+ */
+#undef USE_DNSSERVERS
+
+/*
+ * we check for the existance of struct mallinfo
  */
 #undef HAVE_STRUCT_MALLINFO
+
+/*
+ * Do we want to use truncate(2) or unlink(2)?
+ */
+#undef USE_TRUNCATE
+
+/*
+ * Allow underscores in host names
+ */
+#undef ALLOW_HOSTNAME_UNDERSCORES
+
+/*
+ * Use the heap-based replacement techniques
+ */
+#undef HEAP_REPLACEMENT
Index: squid/configure.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/configure.in,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/configure.in	26 Jan 2000 03:23:09 -0000	1.1.1.2
+++ squid/configure.in	26 Jan 2000 03:25:00 -0000	1.1.1.3
@@ -3,13 +3,13 @@
 dnl
 dnl  Duane Wessels, wessels@nlanr.net, February 1996 (autoconf v2.9)
 dnl
-dnl  $Id: configure.in,v 1.1.1.2 2000/01/26 03:23:09 hno Exp $
+dnl  $Id: configure.in,v 1.1.1.3 2000/01/26 03:25:00 hno Exp $
 dnl
 dnl
 dnl
 AC_INIT(src/main.c)
 AC_CONFIG_HEADER(include/autoconf.h)
-AC_REVISION($Revision: 1.1.1.2 $)dnl
+AC_REVISION($Revision: 1.1.1.3 $)dnl
 AC_PREFIX_DEFAULT(/usr/local/squid)
 AC_CONFIG_AUX_DIR(cfgaux)
 
@@ -124,70 +124,57 @@
     fi
 fi
 
-if test "x$ac_cv_enabled_dlmalloc" = "x"; then
-    case "$host" in
-	i386-*-solaris2.*)
-		echo "Enabling dlmalloc for $host"
-		ac_cv_enabled_dlmalloc="yes"
-		;;
-    esac
-fi
-
 dnl Enable optional modules
 AC_ARG_ENABLE(dlmalloc,
 [  --enable-dlmalloc[=LIB] Compile & use the malloc package by Doug Lea],
 [
- if test "x$ac_cv_enabled_dlmalloc" = "xyes"; then
-   # Ok. dlmalloc was enabled before, but state may be changed.
-   # we have to test these again
-   unset ac_cv_func_mallinfo
-   unset ac_cv_func_mallocblksize
-   unset ac_cv_func_free
-   unset ac_cv_func_realloc
-   unset ac_cv_func_memalign
-   unset ac_cv_func_valloc
-   unset ac_cv_func_pvalloc
-   unset ac_cv_func_calloc
-   unset ac_cv_func_cfree
-   unset ac_cv_func_malloc_trim
-   unset ac_cv_func_malloc_usable_size
-   unset ac_cv_func_malloc_stats
-   unset ac_cv_func_mallopt
-   unset ac_cv_lib_gnumalloc
-   unset ac_cv_header_gnumalloc_h
-   unset ac_cv_lib_malloc
-   unset ac_cv_enabled_dlmalloc
- fi
  case "$enableval" in
  'yes')
+    use_dlmalloc="yes"
     LIBDLMALLOC="libdlmalloc.a"
     LIB_MALLOC="-L../lib -ldlmalloc"
-    ac_cv_func_mallinfo="yes"
-    ac_cv_func_mallocblksize="no"
-    ac_cv_func_free="yes"
-    ac_cv_func_realloc="yes"
-    ac_cv_func_memalign="yes"
-    ac_cv_func_valloc="yes"
-    ac_cv_func_pvalloc="yes"
-    ac_cv_func_calloc="yes"
-    ac_cv_func_cfree="yes"
-    ac_cv_func_malloc_trim="yes"
-    ac_cv_func_malloc_usable_size="yes"
-    ac_cv_func_malloc_stats="yes"
-    ac_cv_func_mallopt="yes"
-    ac_cv_lib_gnumalloc="no"
-    ac_cv_header_gnumalloc_h="no"
-    ac_cv_lib_malloc="no"
-    ac_cv_enabled_dlmalloc="yes"
-    echo "dlmalloc build enabled"
+    echo "dlmalloc enabled"
     ;;
  'no')
-    # Disabled explicitly.
-    echo "dlmalloc disabled."
+    use_dlmalloc="no"
+    echo "dlmalloc disabled"
     ;;
- *)
-    # Use already installed dlmalloc library.
-    LIB_MALLOC="${enableval}"
+ *) use_dlmalloc="yes"
+    LIB_MALLOC="$enableval"
+    echo "dlmalloc enabled with $LIB_MALLOC"
+ esac
+])
+if test "${use_dlmalloc-unset}" = unset; then
+    case "$host" in
+	i386-*-solaris2.*)
+		echo "Enabling dlmalloc for $host"
+		use_dlmalloc="yes"
+		;;
+    esac
+fi
+if test "x$ac_cv_enabled_dlmalloc" = "xyes"; then
+    # Ok. dlmalloc was enabled before, but state may be changed.
+    # we have to test these again
+    unset ac_cv_func_mallinfo
+    unset ac_cv_func_mallocblksize
+    unset ac_cv_func_free
+    unset ac_cv_func_realloc
+    unset ac_cv_func_memalign
+    unset ac_cv_func_valloc
+    unset ac_cv_func_pvalloc
+    unset ac_cv_func_calloc
+    unset ac_cv_func_cfree
+    unset ac_cv_func_malloc_trim
+    unset ac_cv_func_malloc_usable_size
+    unset ac_cv_func_malloc_stats
+    unset ac_cv_func_mallinfo
+    unset ac_cv_func_mallopt
+    unset ac_cv_lib_gnumalloc
+    unset ac_cv_header_gnumalloc_h
+    unset ac_cv_lib_malloc
+    unset ac_cv_enabled_dlmalloc
+fi
+if test "$use_dlmalloc" = yes; then
     ac_cv_func_mallinfo="yes"
     ac_cv_func_mallocblksize="no"
     ac_cv_func_free="yes"
@@ -205,32 +192,8 @@
     ac_cv_header_gnumalloc_h="no"
     ac_cv_lib_malloc="no"
     ac_cv_enabled_dlmalloc="yes"
-    echo "Use installed dlmalloc."
-    ;;
- esac
- ],[
- if test "x$ac_cv_enabled_dlmalloc" = "xyes"; then
-   # Ok. dlmalloc was enabled before, but now disabled.
-   # we have to test these again
-   unset ac_cv_func_mallinfo
-   unset ac_cv_func_mallocblksize
-   unset ac_cv_func_free
-   unset ac_cv_func_realloc
-   unset ac_cv_func_memalign
-   unset ac_cv_func_valloc
-   unset ac_cv_func_pvalloc
-   unset ac_cv_func_calloc
-   unset ac_cv_func_cfree
-   unset ac_cv_func_malloc_trim
-   unset ac_cv_func_malloc_usable_size
-   unset ac_cv_func_malloc_stats
-   unset ac_cv_func_mallopt
-   unset ac_cv_lib_gnumalloc
-   unset ac_cv_header_gnumalloc_h
-   unset ac_cv_lib_malloc
-   unset ac_cv_enabled_dlmalloc
- fi
- ])
+fi
+
 AC_SUBST(LIBDLMALLOC)
 AC_SUBST(LIB_MALLOC)
 
@@ -274,8 +237,26 @@
 ])
 
 AC_ARG_ENABLE(async_io,
-[  --enable-async-io       Do ASYNC disk I/O using threads],
-[ if test "$enableval" = "yes" ; then
+[  --enable-async-io[=N_THREADS]
+                          Do ASYNC disk I/O using threads.
+                          N_THREADS is the number of worker threads
+                          defaults to 16. See also src/squid.h for
+                          some additional platform tuning],
+[ case "$enableval" in
+  yes)
+    async_io=yes
+    ;;
+  no)
+    async_io=''
+    ;;
+  *)
+    async_io=yes
+    AC_DEFINE_UNQUOTED(NUMTHREADS, $enableval)
+    ;;
+  esac
+])
+
+if test -n "$async_io" ; then
     echo "Async I/O enabled"
     async_io=yes
     AC_DEFINE(USE_ASYNC_IO)
@@ -291,8 +272,7 @@
 	fi
 	;;
     esac
-  fi
-])
+fi
 AC_SUBST(ASYNC_OBJS)
 AC_SUBST(SQUID_PTHREAD_LIB)
 
@@ -330,6 +310,16 @@
   fi
 ])
 
+AC_ARG_ENABLE(wccp,  
+[  --disable-wccp      Disable Web Cache Coordination Protocol],
+[ if test "$enableval" = "no" ; then
+    echo "Web Cache Coordination Protocol disabled"
+    AC_DEFINE(USE_WCCP, 0)
+  else
+    AC_DEFINE(USE_WCCP, 1)
+  fi
+])      
+
 AC_ARG_ENABLE(kill_parent_hack,
 [  --enable-kill-parent-hack
                           Kill parent on shutdown],
@@ -513,6 +503,57 @@
   fi
 ])
 
+AC_ARG_ENABLE(internal-dns,
+[  --disable-internal-dns  This prevents Squid from directly sending and
+                          receiving DNS messages, and instead enables the
+                          old external 'dnsserver' processes.],
+[ if test "$enableval" = "no" ; then
+    echo "Disabling Internal DNS queries"
+    AC_DEFINE(USE_DNSSERVERS, 1)
+  else
+    AC_DEFINE(USE_DNSSERVERS, 0)
+  fi
+])
+
+AC_ARG_ENABLE(truncate,
+[  --enable-truncate       This uses truncate() instead of unlink() when
+                          removing cache files.  Truncate gives a little
+                          performance improvement, but may cause problems
+                          when used with async I/O.  Truncate uses more
+                          filesystem inodes than unlink..],
+[ if test "$enableval" = "yes" ; then
+    echo "Enabling truncate instead of unlink"
+    AC_DEFINE(USE_TRUNCATE)
+  fi
+])
+
+dnl Enable underscore in hostnames
+AC_ARG_ENABLE(underscores,
+[  --enable-underscores    Squid by default rejects any host names with _
+                          in their name to conform with internet standars.
+                          If you disagree with this you may allow _ in
+                          hostnames by using this switch, provided that
+                          the resolver library on the host where Squid runs
+                          does not reject _ in hostnames...],
+[ if test "$enableval" = "yes" ; then
+    echo "Enabling the use of underscores in host names"
+    AC_DEFINE(ALLOW_HOSTNAME_UNDERSCORES, 1)
+  fi
+])
+
+dnl Enable HEAP_REPLACEMENT
+AC_ARG_ENABLE(heap-replacement,
+[  --enable-heap-replacement
+                          This option allows you to use various cache
+                          replacement algorithms, instead of the standard
+                          LRU algorithm.
+                          ],
+[ if test "$enableval" = "yes" ; then
+    echo "Enabling HEAP_REPLACEMENT"
+    AC_DEFINE(HEAP_REPLACEMENT, 1)
+  fi
+])
+
 # Force some compilers to use ANSI features
 #
 case "$host" in
@@ -919,7 +960,6 @@
 AC_CHECK_FUNCS(\
 	bcopy \
 	crypt \
-	drand48 \
 	fchmod \
 	getdtablesize \
 	getpagesize \
@@ -943,6 +983,7 @@
 	res_init \
 	rint \
 	seteuid \
+	setgroups \
 	setpgrp \
 	setrlimit \
 	getrlimit \
@@ -953,7 +994,6 @@
 	srandom \
 	sysconf \
 	syslog \
-	tempnam \
 	timegm \
 	vsnprintf \
 )
@@ -1080,6 +1120,14 @@
 
 dnl Not cached since people are likely to tune this
 AC_MSG_CHECKING(Maximum number of filedescriptors we can open)
+dnl shit! FreeBSD's pthreads breaks dup2().
+TLDFLAGS="$LDFLAGS"
+case $host in
+i386-unknown-freebsd*)
+    if echo "$LDFLAGS" | grep -q pthread; then
+	LDFLAGS=`echo $LDFLAGS | sed -e "s/-pthread//"`
+    fi
+esac
 AC_TRY_RUN([
 #include <stdio.h>
 #include <unistd.h>
@@ -1094,8 +1142,7 @@
      * Number of fds is virtually unlimited in cygwin (sys/param.h)
      */
     i = NOFILE;
-#else
-#if HAVE_SETRLIMIT
+#elif HAVE_SETRLIMIT
     struct rlimit rl;
 #if defined(RLIMIT_NOFILE)
     if (getrlimit(RLIMIT_NOFILE, &rl) < 0) {
@@ -1117,27 +1164,19 @@
     }
 #endif /* RLIMIT_NOFILE */
 #endif /* HAVE_SETRLIMIT */
-#if defined(__linux__) && HAVE_GETRLIMIT && defined(RLIMIT_NOFILE)
-	if (getrlimit(RLIMIT_NOFILE, &rl) < 0) {
-		perror("getrlimit: RLIMIT_NOFILE");
-	}
-	i = rl.rlim_cur;
-#elif HAVE_SYSCONF && defined(_SC_OPEN_MAX)
-        i = sysconf(_SC_OPEN_MAX);
-#elif HAVE_GETDTABLESIZE && !defined(__linux__)
-        i = getdtablesize();
-#elif defined(OPEN_MAX)
-        i = OPEN_MAX;
-#elif defined(NOFILE)
-        i = NOFILE;
-#elif defined(_NFILE)
-        i = _NFILE;
-#else
-	while((j=open("/dev/null", 0)) > 0) i=j;
-        close(i); close(i-1);
-	i++;
-#endif
-#endif /* __CYGWIN32__ */
+	/* by starting at 2^14, we will never get higher
+	than 2^15 for SQUID_MAXFD */
+        i = j = 1<<14;
+        while (j) {
+                j >>= 1;
+                if (dup2(0, i) < 0) { 
+                        i -= j;
+                } else {
+                        close(i);
+                        i += j;
+                }
+        }
+        i++;
 	fp = fopen("conftestval", "w");
 	fprintf (fp, "%d\n", i);
 	exit(0);
@@ -1155,6 +1194,7 @@
     echo "         on how to increase your filedescriptor limit"
     sleep 10
 fi
+LDFLAGS="$TLDFLAGS"
 
 dnl Not cached since people are likely to tune this
 AC_MSG_CHECKING(Default UDP send buffer size)
@@ -1261,7 +1301,7 @@
 AC_DEFINE_UNQUOTED(SQUID_TCP_SO_RCVBUF, $SQUID_TCP_SO_RCVBUF)
 
 AC_CACHE_CHECK(if sys_errlist is already defined, ac_cv_needs_sys_errlist,
-  AC_TRY_COMPILE([#include <stdio.h>],[char *s = sys_errlist[0];],
+  AC_TRY_COMPILE([#include <stdio.h>],[char *s = sys_errlist;],
     ac_cv_needs_sys_errlist="no",
     ac_cv_needs_sys_errlist="yes")
 )
@@ -1424,5 +1464,8 @@
 	./errors/Makefile \
 	./auth_modules/dummy \
 	./auth_modules/NCSA/Makefile \
+	./auth_modules/PAM/Makefile \
+	./auth_modules/SMB/Makefile
 	./auth_modules/getpwnam/Makefile \
+	./auth_modules/LDAP/Makefile \
 )
Index: squid/auth_modules/PAM/pam_auth.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/PAM/Attic/pam_auth.c,v
retrieving revision 1.1
retrieving revision 1.1.1.1
diff -u -r1.1 -r1.1.1.1
--- squid/auth_modules/PAM/pam_auth.c	26 Jan 2000 03:25:00 -0000	1.1
+++ squid/auth_modules/PAM/pam_auth.c	26 Jan 2000 03:25:00 -0000	1.1.1.1
@@ -1,5 +1,5 @@
 /*
- * $Id: pam_auth.c,v 1.1 2000/01/26 03:25:00 hno Exp $
+ * $Id: pam_auth.c,v 1.1.1.1 2000/01/26 03:25:00 hno Exp $
  *
  * PAM authenticator module for Squid.
  * Copyright (C) 1999 Henrik Nordstrom <hno@hem.passagen.se>
Index: squid/auth_modules/SMB/Changelog
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/SMB/Attic/Changelog,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/auth_modules/SMB/Changelog	26 Jan 2000 03:23:09 -0000	1.1.1.1
+++ squid/auth_modules/SMB/Changelog	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,3 +1,33 @@
+28 September 1999, version 0.05
+
+- Easier debugging: added the -d option to smb_auth.
+
+- Bugfix: a password containing a backslash character was always
+  denied. Reported by Menno Stevens.
+
+- The -S option now accepts both slashes and backslashes and
+  allows the share name to be preceded by a (back)slash.
+
+5 June 1999, version 0.04
+
+- Allow for both \n and \r\n end-of-line termination in the
+  proxyauth file located on the PDC. This eliminates the most
+  common installation problem.
+
+- The location of the proxyauth file can be changed (for each
+  domain) using the new -S option. Useful when the NETLOGON
+  share is located on a FAT filesystem.
+  Thanks to Colin Manning <colinm@officeinfo.com.au>.
+
+2 Februari 1999, version 0.03
+
+- Support for pass-through authentication (trust relationships)
+  added. Suggested by Matthew Wood <woodm@newsltd.com.au>.
+
+- Bugfix: smb_auth.sh searched for the PDC only.
+
+- Many documentation improvements.
+
 9 December 1998, version 0.02
 
 - smb_auth now uses Samba instead of pam_smb. This simplifies the
